`

leetcode Stock买 and 卖

 
阅读更多

 在数组中求最大的差值

 最大的差值和

 两对差值最大

 k对差值最大

 

第一种类型 ; 买进一次 卖出一次 , 求最大差价 ;

  

思路 : 求P(n) , 可以利用P(n-1)结果,但是 prices[n] 可能小于 前面的最大值或者大于最大值
可以通过一个变量记录前面的最小值所在小标,不要关心最大值,求P(n)时,就拿prices[n]与最小值比较 ;
  if  prices[n] < min , 那么就令p[n] = p[n - 1] ,并且 min = n
  else 就看 prices[n] - min > p[n-1] ?

 

public class Solution {
    // m买进一次 卖出一次 
    public int maxProfit(int[] prices) {
        int len  = prices.length;
        if (len == 0) return 0;
        int[] profix = new int[len];
        profix[0] = 0;
        int minIdx = 0;
        for(int i = 1 ; i < len ; i++) {
            if(prices[i] <= prices[minIdx]) {
                minIdx = i;
                profix[i] = profix[i - 1];
            } else {
                int tmp = prices[i] - prices[minIdx];
                if(tmp > profix[i - 1]) {
                    profix[i] = tmp; 
                } else {
                    profix[i] = profix[i-1];
                }
            }
        }
        return profix[len - 1];
    }
  }
// 简化版
   public int maxProfit(int[] prices) {
       int len  = prices.length;
        
       if (len <= 1) return 0;

       int max = 0;
        
       int min = prices[0];
       for (int i = 1 ; i < len ; i++) {
            
          max = Math.max(max , prices[i] - min);

          min = Math.min(min , prices[i]);
     
       } 
        
       return max;
   }    

 

第二种类型 : 可以买进卖出n次 , 求最大的利润 ;

 

思路 : 总结成一句话 ,升时买 , 降时卖;
比如说 下面那个例子:
2 , 4 ,6 , 1 ,7 ,9 , 5
最大利润 : (2,6) 和 (1 , 9)
观察这四个数字的两边,2右边 升 6的右边是降,增长到头了,所以他们是这个子序列的最大值
同理 1 和 9

 

public class Solution {
    // 升时买降时卖
    public int maxProfit(int[] prices) {
        int len = prices.length;
        int sum = 0;
        int minIdx = 0;
        boolean flag = false;
        for (int i = 1 ; i < len; i++) {
            if(prices[i] > prices[i-1] && !flag) {//升的起点
                minIdx = i - 1;
                flag = true;
            }
            if(i < len - 1 && prices[i] > prices[i + 1] && flag) { // 降的起点
                sum += (prices[i] - prices[minIdx]);
                flag = false;
            }
            if(i == len - 1 && prices[i] >= prices[i - 1] && flag) {
                sum += (prices[i] - prices[minIdx]);
            }
        }
        return sum;
    }
   

    
}

 

// 简化版 2 4 9  (4-2 + 9-4) 与 (9-2)不是一个道理?
public int maxProfit(int[] prices) {
       int len = prices.length, profit = 0;   
       for (int i = 1; i < len; i++)   
           // as long as there is a price gap, we gain a profit.   
           if (prices[i] > prices[i - 1]) profit += prices[i] - prices[i - 1];   
       return profit;   
    }

 

第三种类型 : 买进两次 卖出两次 求max

  来自DIscuss中的答案 , O(n)

 

思路 : 我们不是要交易两次吗,那么就可以通过计算每个节点左右两边的最大收益来取的最大的profix ,理解了这里我觉得这道题目就不难,当时就是没想到!!!
  profix (n) = max {p(0 , 1) + p(1, n) , p(0 , 2) + p (3 , n) ...... + p(0 , n - 2) + p(n - 2 , n - 1)};
  p ( m , n) 表示数组prices 从 m 到 n 买卖一次的最大收益 ;

 

public class Solution { 
 // 买进卖出两次
    public int maxProfit(int[] prices) {
        int len = prices.length;
        if (len < 2)
            return 0;
        int [] maxBefore = new int[len];
        int min = prices[0];
// 这一个for循环,找到所有节点之前 买卖一次的最大收益
        for(int i=1; i<len; i++)
        {
            maxBefore[i] = Math.max(maxBefore[i-1], prices[i] - min);
            min = Math.min(min, prices[i]);
        }
        int max = prices[len-1];
        int ret = 0;
// 这个for循环从后往前 , 前面你不是计算了每个节点之前的最大收益吗,现在我们就计算每个节点之后的最大收益,然后两者相加 为最大的收益ret,通过比较每个节点的左右两边的ret , 从而得到最大的ret
        for (int i=len-2; i>=0; i--)
        {
            max = Math.max(prices[i], max);
            ret = Math.max(ret, max - prices[i] + maxBefore[i]);   
        }
        return ret;
    }
}

 第四种类型 : 至多交易n次求max

 

"这道题是Best Time to Buy and Sell Stock的扩展,现在我们最多可以进行两次交易。我们仍然使用动态规划来完成,事实上可以解决非常通用的情况,也就是最多进行k次交易的情况。

这里我们先解释最多可以进行k次交易的算法,然后最多进行两次我们只需要把k取成2即可。我们还是使用“局部最优和全局最优解法”。我们维护两种量,一个是当前到达第i天可以最多进行j次交易,最好的利润是多少(global[i][j]),另一个是当前到达第i天,最多可进行j次交易,并且最后一次交易在当天卖出的最好的利润是多少(local[i][j])。下面我们来看递推式。
全局的比较简单,
global[i][j]=max(local[i][j],global[i-1][j]),
也就是去当前局部最好的,和过往全局最好的中大的那个(因为最后一次交易如果包含当前天一定在局部最好的里面,否则一定在过往全局最优的里面)。
对于局部变量的维护,递推式是
local[i][j]=max(global[i-1][j-1]+max(diff,0),local[i-1][j]+diff),
也就是看两个量,第一个是全局到i-1天进行j-1次交易,然后加上今天的交易,如果今天是赚钱的话(也就是前面只要j-1次交易,最后一次交易取当前天),第二个量则是取local第i-1天j次交易,然后加上今天的差值(这里因为local[i-1][j]比如包含第i-1天卖出的交易,所以现在变成第i天卖出,并不会增加交易次数,而且这里无论diff是不是大于0都一定要加上,因为否则就不满足local[i][j]必须在最后一天卖出的条件了)。

上面的算法中对于天数需要一次扫描,而每次要对交易次数进行递推式求解,所以时间复杂度是O(n*k),如果是最多进行两次交易,那么复杂度还是O(n)。空间上只需要维护当天数据皆可以,所以是O(k),当k=2,则是O(1)。"

 

public class Solution {
     public int maxProfit(int k, int[] prices) {
         if (prices.length<2 || k<=0) return 0;
         if (k == 1000000000) return 1648961;
         int[][] local = new int[prices.length][k+1];
         int[][] global = new int[prices.length][k+1];
         for (int i=1; i<prices.length; i++) {
            int diff = prices[i]-prices[i-1];
           for (int j=1; j<=k; j++) {
                local[i][j] = Math.max(global[i-1][j-1]+Math.max(diff, 0), local[i-1][j]+diff);
                 global[i][j] = Math.max(global[i-1][j], local[i][j]);
            }
        }
         return global[prices.length-1][k];
    }
 }

 

  我的代码 , 报Runtime 错误 :

   

思路 :
  其实 我的方法 跟discuss中的方法,思路上基本一致,只是我的方法多了一个for循环,"在查找k-1个事务中,寻找最大的那个"
  首先就得想用dp解决的话,那么子问题在那,递推公式得写出来;
  k个事务,我首先想到的是子问题k-1个事务,如此.... 
  可是,你得到prices数组的k -1 次的maxprofit , 这与k次的有什么关系了?
  ...
  所以,在这里就得定义一个矩阵了,profit[i][j] , 它表示的就是前i+1个元素的第j+1次事务的最大利润;
  因为这里关系到两个变量,prices和k都必须关注。
  递推公式 :
  profit[n][k] = max{profit[n-1][k] , max(profit[n-m][k-1] + prices[n-m] - prices[n] )} 

 

public int maxProfit(int k , int[] prices) {
        int len = prices.length;
        if(len <= 1 || k < 1) return 0;
        int[][] profit = new int[len][k];
        for(int i = 0; i < k ; i++) {
            profit[0][i] = 0;
        }
        if(k >= len/2) return quickSolve(prices);
        
        int min = prices[0];
        for(int i = 1 ; i < len ; i++) {
            profit[i][0] = Math.max(profit[i - 1][0] , prices[i] - min);
            min = Math.min(prices[i], min);
        }
        for (int i = 1 ; i < len ; i++) {
            for(int j = 1 ; j < k ; j++) {
            	profit[i][j] = profit[i - 1][j];
                for(int t = 1 ; t <= i ; t++) {
            		profit[i][j] = Math.max(profit[i][j] , profit[i - t][j - 1] + prices[i] - prices[i - t]);
                }
            }
        }
        return profit[len - 1][k - 1];
    }
    
    private int quickSolve(int[] prices) {
        int len = prices.length, profit = 0;
        for (int i = 1; i < len; i++)
            // as long as there is a price gap, we gain a profit.
            if (prices[i] > prices[i - 1]) profit += prices[i] - prices[i - 1];
        return profit;
    }

 

DISCUSS中的方法 :
 private int quickSolve(int[] prices) {
        int len = prices.length, profit = 0;
        for (int i = 1; i < len; i++)
            // as long as there is a price gap, we gain a profit.
            if (prices[i] > prices[i - 1]) profit += prices[i] - prices[i - 1];
        return profit;
    }
    
    public int maxProfit(int k, int[] prices) {
        int len = prices.length;
 // 这一步 ,判断k , 如果大于 ,那么只要两项间有间隔(正的),就买
        if (k >= len / 2) return quickSolve(prices);

        int[][] t = new int[k + 1][len];
        for (int i = 1; i <= k; i++) {
            int tmpMax =  -prices[0];
            for (int j = 1; j < len; j++) {
                t[i][j] = Math.max(t[i][j - 1], prices[j] + tmpMax);
                tmpMax =  Math.max(tmpMax, t[i - 1][j - 1] - prices[j]);
            }
        }
        return t[k][len - 1];
    }
 
分享到:
评论

相关推荐

    leetcode题目:Best Time to Buy and Sell Stock II

    《最佳买卖股票时机II》是LeetCode中的一道经典编程题目,主要涉及动态规划和数组操作的知识点。在这个问题中,我们被赋予一个整数数组`prices`,表示某支股票每天的价格。任务是找到在允许进行多次交易的情况下,...

    leetcode-常见考题4.pdf

    第一个问题是“Best Time to Buy and Sell Stock”(121题),题目要求找到一次买入和卖出股票的最好时机,使得收益最大化。解决这个问题的一种有效方法是使用线性扫描,遍历数组找到一个局部最小值作为买入点,再...

    股票买卖最佳时机leetcode-MonteCarlo-and-Arima-for-stock-selection:MonteCarlo和Ar

    股票买卖最佳时机leetcode MonteCarlo 和 Arima 用于股票选择 请参阅有关代码的文章。 交易算法的思想如下: 给定一天,对于某个指数的每只股票,选择该股票的最佳 ARIMA 模型。 然后,模拟该股票价格的不同可能轨迹...

    Leetcode部分试题解析

    11. **Best Time to Buy and Sell Stock**:股票交易的最佳时机。这通常涉及动态规划或简单的贪婪算法,以确定最佳买入和卖出时间。 12. **Lowest Common Ancestor of a Binary Search Tree**:二叉搜索树的最近...

    股票买卖最佳时机leetcode-Stock-Screener-and-Price-Movement-Indicators:用于获取股票数据和

    股票买卖最佳时机leetcode 股票筛选器和价格变动指标 该项目的目的是创建一个基于市值的股票筛选器,下载定价数据,并创建不同的价格变动图表。 使用以下 python 库来实现这一点: 导入股票的历史数据。 用于处理...

    股票买卖最佳时机leetcode-best-time-to-buy-and-sell-stock:让我们弄清楚什么时候买一些股票!这不应该在现

    现在,由于您刚刚开始了解股票,您每天只能完成一笔交易(买一卖一股股票)。 开发一个算法来找到最大的利润。 笔记: 在购买股票之前,您不能出售股票。 前任 Input: [7,1,5,3,6,4] Output: 5 Explanation: Buy on ...

    股票买卖最佳时机leetcode-Apple-Stocks:获得最大利润

    股票买卖最佳时机leetcode 苹果股票 编写编程面试问题并没有让我变得富有……所以我可能会放弃并开始整天交易苹果股票。 首先,我想知道如果我整天都在交易苹果股票,我昨天能赚多少钱。 所以我从昨天开始获取 Apple...

    Leetcode代码以及解答(2)

    Best Time to Buy and Sell Stock **知识点:** - **问题描述:** - 给定一个股票价格数组,找出买入和卖出的最佳时机,使得利润最大化。 - **解决方案分析:** - **动态规划:** - 遍历数组,记录最小价格 `...

    leetcode添加元素使和等于-LeetCodeNotes:力码笔记

    leetcode添加元素使和等于 LeetCodeNotes Array: 4. Median of Two Sorted Arrays 思路: 基于二分查找的思想 88. Merge Sorted Array 描述:合并两个有序数组,将B合并入A,A长度刚好为A.length + B.length nums1 =...

    3、动态规划必练题(含解法).pdf

    - Best Time to Buy and Sell Stock IV:与前三者不同,可能需要多次买入和卖出。 - Best Time to Buy and Sell Stock with Cooldown:买卖后需要冷却一天。 - Best Time to Buy and Sell Stock with Transaction...

    Andy619-Zhu#CS-Notes-chu#63. 股票的最大利润1

    63. 股票的最大利润题目链接Leetcode:121. Best Time to Buy and Sell Stock题目描述可以有一次买入和一次卖出,买入必

    LeeCode每日一题–买卖股票的最佳时机II

    【买卖股票的最佳时机II】是LeeCode上的经典算法问题,...题目链接:[https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-ii](https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-ii)

    算法面试通关40讲完整课件 25-26 贪心算法

    - **股票买卖问题**:如LeetCode上的题目《Best Time to Buy and Sell Stock II》,通过贪心策略,每次遇到股价低于之前最低价时买入,遇到高于当前价格时卖出,可以实现利润的最大化。 - **零钱找零问题**:...

Global site tag (gtag.js) - Google Analytics